function[Mat1Fin, Mat3Fin, Mat2Temp, Mat4Temp] = hpp1(Mat1, Mat2, Mat3, Mat4)
% HPP Hardy, Pomeau, Pazzis ; vertical
% En cas de collision, le vecteur haut devient droit et le bas devient
% gauche.
m = size(Mat1,1); n = size(Mat1,2);
Mat1Fin = zeros(m, n); Mat3Fin = zeros(m, n);
Mat2Temp = zeros(m, n); Mat4Temp = zeros(m, n); % Matrices temporaires
                                                % stockant les cellules qui
                                                % ont changé de vecteur,
                                                % mais qui se meuvent selon
                                                % le vecteur précédent pour
                                                % cette période

Mat1Up = circshift(Mat1,[-2,0]);
Mat3Down = circshift(Mat3,[2,0]);
Mat2Down = circshift(Mat2,[1,1]); Mat2Up = circshift(Mat2,[-1,1]);
Mat4Down = circshift(Mat4,[1,-1]); Mat4Up = circshift(Mat4,[-1,-1]);

for i=1:m
    for j=1:n
        if Mat1(i,j) == 1 % S'il y a vecteur haut, test collisions
            if Mat3Down(i,j) == 0 % S'il n'y a pas de collision frontale...
                Mat1Fin(i,j) = 1; % ...la particule garde son vecteur
            end
            if Mat3Down(i,j) == 1 % Sinon...
                Mat2Temp(i,j) = 1; % ...son vecteur change (mais il
                                   % continue à monter pour cette période)
            end
        end
        if Mat3(i,j) == 1 % S'il y a vecteur bas, test collisions
            if Mat1Up(i,j) == 0 % S'il n'y a pas de collision frontale...
                Mat3Fin(i,j) = 1; % ...la particule garde son vecteur
            end
            if Mat1Up(i,j) == 1  % Sinon...
                Mat4Temp(i,j) = 1; % ...son vecteur change (mais il
                                   % continue à monter pour cette période)
            end
        end
    end
end

Mat2Temp = circshift(Mat2Temp,[-1,0]);
Mat4Temp = circshift(Mat4Temp,[1,0]);

Mat1Fin = circshift(Mat1Fin,[-1,0]); % On monte la MatFin pour permettre le mouvement
Mat3Fin = circshift(Mat3Fin,[1,0]); % On descend la MatFin pour permettre le mouvement