function[Ux2] = run(T)

m = 75; n = 75; u0 = 0.1; Re = 1000
tau = 3*u0*m/Re + 1/2
%nu = (tau-1/2)/3
%tau = 1

[FIn] = matgen(m,n,u0);
Img = zeros(m,n);

for i = 1 : 9
    Img = Img + FIn(:,:,i);
end

imagesc(Img); colorbar;

for t = 1 : T
    [FIn, rho, ux, uy] = lattboltz(FIn, tau, u0);
    pos = [-1 -0.8906 -0.875 -0.8594 -0.7968 -0.6562 -0.4374 -0.0938 0 0.2344 0.4688 0.7032 0.9062 0.9218 0.9376 0.9532 1]';
    [N,~] = size(pos);
    Ux = [0 -0.18109 -0.20196 -0.2222 -0.2973 -0.38289 -0.27805 -0.10648 -0.0608 0.05702 0.18719 0.33304 0.46604 0.51117 0.57492 0.65928 1]';
    if mod(t,10000) == 0
        t
        figure(1); imagesc(rho); colorbar;
        %[sx sy] = meshgrid(1:25:m, 1:25:n); streamline(ux, uy, sx, sy);
        %figure(2); imagesc(ux); colorbar;
        %figure(3); imagesc(uy); colorbar;
        %figure(4); imagesc(sqrt(ux.^2+uy.^2)); colorbar;
        figure(5); plot(pos,Ux,'k');
        figure(5); plot(pos,Ux,'kx');
        hold on
        Ux2 = zeros(N);
        for i = 1 : N
            Ux2(i) = ux(round(-pos(i)*((m - 1)/2)+((m - 1)/2)) + 1, round(n/2))/u0;
        end
        plot(pos,Ux2);
        E = 0;
        for i = 1 : N
            E = E + (Ux2(i)-Ux(i))*(Ux2(i)-Ux(i));
        end
        E = sqrt(E / N)
        if t == 10000
            plot(pos,Ux2,'r');
        end
        if mod(t,100000) == 0
            plot(pos,Ux2,'g');
        end
    end
end